<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover {
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">

    </div>
    <div class="container ">
        <h1 class="text-center text-danger mt-5">Lucky Dice Project</h1>
        <p class="text-center text-info mb-5">Branch 1 test</p>
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12">
                        <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">
                        <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  ">
                        <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">
                        <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">
                        <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">
                        <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  ">
                        <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center">
                <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center">
                <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   ">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group">
            <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row ">
            <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_READYSTATE_FINISH_RESPONSE_READY = 4;
    const gREQUEST_STATUS_OK = 200;
    var vUserObj = {
        firstname: "",
        lastname: "",
        username: "",
    }
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
        $("#inp-user-name").val("huyqh");
        $("#inp-first-name").val("Huy");
        $("#inp-last-name").val("Hoang");

        $("#btn-dice").click(function () {
            themDuLieuUser(vUserObj);
            if (kiemTraDuLieuUser(vUserObj)) {
                console.log(vUserObj);
                onBtnGetNewDiceClick(vUserObj);
            }
        })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //ham them du lieu vao user obj
    function themDuLieuUser(paramObj) {
        var vUserName = $("#inp-user-name");
        var vFirstName = $("#inp-first-name");
        var vLastName = $("#inp-last-name");

        paramObj.username = $.trim(vUserName.val());
        paramObj.firstname = $.trim(vFirstName.val());
        paramObj.lastname = $.trim(vLastName.val());
    }
    //kiem tra du lieu nhap
    function kiemTraDuLieuUser(paramObj) {
        if (paramObj.username == "") {
            alert("User name khong duoc de trong");
            return false;
        }

        if (paramObj.firstname == "") {
            alert("First name khong duoc de trong");
            return false;
        }

        if (paramObj.lastname == "") {
            alert("Last name khong duoc de trong");
            return false;
        }

        return true;
    }
    // Function get new dice handle
    function onBtnGetNewDiceClick(vDataObject) {
        "use strict";
        //base urlbaseUrk
        const vBaseUrl = "../devcamp-lucky-dice";
        const vUtf8TextApplicationHeader = "application/json;charset=UTF-8";
        console.log(vBaseUrl);
        // create a request
        var vXmlHttpDice = new XMLHttpRequest();
        vXmlHttpDice.open("POST", vBaseUrl + "/dice", true);
        vXmlHttpDice.setRequestHeader("Content-Type", vUtf8TextApplicationHeader);
        vXmlHttpDice.send(JSON.stringify(vDataObject));  //chuyển Json object sang string

        vXmlHttpDice.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READYSTATE_FINISH_RESPONSE_READY
                && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                showResultDice(vXmlHttpDice.responseText);
                console.log(vXmlHttpDice.responseText);
            }
        }

    }
    //hàm xử lý với dice trả về
    function showResultDice(responseText) {
        var vDiceObj = JSON.parse(responseText);

        var vDice = vDiceObj.dice;
        var vDiceImg = $("#img-dice");
        var vDiceNotification = $("#p-notification-dice");
        var vVoucherId = $("#p-voucher-id");
        var vVoucherPercent = $("#p-voucher-percent");
        var vImgPresent = $("#img-present");

        if (vDiceObj.voucher != null) {
            vVoucherId.html(vDiceObj.voucher.maVoucher);
            vVoucherPercent.html(vDiceObj.voucher.phanTramGiamGia + "%");
        }

        console.log(vDice)
        switch (vDice) {
            case 1:
                vDiceNotification.html("Chúc bạn may mắn lần sau.");
                vDiceImg.prop("src", "LuckyDiceImages/1.png");
                vImgPresent.prop("src", "LuckyDiceImages/no-present.jpg");
                break;
            case 2:
                vDiceNotification.html("Chúc bạn may mắn lần sau.");
                vDiceImg.prop("src", "LuckyDiceImages/2.png");
                vImgPresent.prop("src", "LuckyDiceImages/no-present.jpg");
                break;
            case 3:
                vDiceNotification.html("Chúc mừng bạn.");
                vDiceImg.prop("src", "LuckyDiceImages/3.png");
                vImgPresent.prop("src", "LuckyDiceImages/hat.jpg");
                break;
            case 4:
                vDiceNotification.html("Chúc mừng bạn.");
                vDiceImg.prop("src", "LuckyDiceImages/4.png");
                vImgPresent.prop("src", "LuckyDiceImages/t-shirt.jpg");
                break;
            case 5:
                vDiceNotification.html("Chúc mừng bạn.");
                vDiceImg.prop("src", "LuckyDiceImages/5.png");
                vImgPresent.prop("src", "LuckyDiceImages/motobike.jpg");
                break;
            case 6:
                vDiceNotification.html("Chúc mừng bạn.");
                vDiceImg.prop("src", "LuckyDiceImages/6.png");
                vImgPresent.prop("src", "LuckyDiceImages/car.jpg");
                break;
            default:
                break;
        }
    }
</script>

</html>